require "class"
require "tiles"
require "gameGrid"
function love.load()
math.randomseed( os.time() )
math.random(); math.random(); math.random()
G_HighScore = 0
if love.filesystem.exists( "HIGHSCORE" ) then
	G_HighScore = LoadHighScore()
end
--Music
G_Music = {}
G_Music[1] = love.audio.newSource( "music/Tetris_Harmi.mp3", "stream" )
G_Music[1]:setLooping(true)
G_Music[2] = love.audio.newSource( "music/Tetris_Kraakkel.mp3", "stream" )
G_Music[2]:setLooping(true)
G_Music[3] = love.audio.newSource( "music/Tetris_Mortimer.mp3", "stream" )
G_Music[3]:setLooping(true)
G_Music[4] = love.audio.newSource( "music/Tetris_Pulle.mp3", "stream" )
G_Music[4]:setLooping(true)
G_Music_Current = 1
----Sounds
G_SoundScore = love.audio.newSource( "sound/score.wav", "static" )
G_SoundEnd = love.audio.newSource( "sound/game_end.wav", "static" )
--G_SoundTile = love.audio.newSource( "sound/", "static" )
--
local _, _, flags = love.window.getMode()
local width, height = love.window.getDesktopDimensions( flags.display )
width = width - 10
height = height - 10 - 50
local success = love.window.setMode( width, height, flags )
love.window.setPosition( 5, 5, flags.display )
G_WW = width
G_WH = height
G_FH = 40/1050*height
--DAFont = love.graphics.newFont("fonts/editundo.ttf", 20);
G_GfxTextOffsetY = 200/1050*height
G_GfxTextOffsetX = 550/1680*width
ENDFont = love.graphics.newFont("fonts/editundo.ttf", G_FH);
love.graphics.setFont(ENDFont);
G_GameGrid = GameGrid(10,20)
G_GameSpeed = 2
G_GameTimer = 0
DDText = ""
G_GameScore = 0
G_GamePaused = true
G_GameEnded = false
love.keyboard.setKeyRepeat( true )
G_MusicEnabled = true
	G_Music[G_Music_Current]:play()
end

function love.update(dt)
	if not G_GamePaused then
		G_GameTimer = G_GameTimer + dt
		if G_GameTimer >= G_GameSpeed then
			G_GameTimer = G_GameTimer - G_GameSpeed
			G_GameGrid:UpdateGridDown()
		end
	end
end

function love.draw()
	G_GameGrid:Render()
	love.graphics.setColor(255,255,255,255)
	--love.graphics.print("FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	--love.graphics.print("Debug: " .. DDText, 350, 10)
	love.graphics.print("Highscore: " .. 	G_HighScore , G_GfxTextOffsetX, 3)
	if G_MusicEnabled then
		love.graphics.print("Current (M)usic ID: " .. G_Music_Current, G_GfxTextOffsetX, G_WH-G_FH-3)
	end
	if G_GameEnded then
		love.graphics.print("Score: " .. G_GameScore .. "\n::GAME OVER::\n\nPress ENTER to Restart.\n\nPress ESCAPE to quit.", G_GfxTextOffsetX, G_GfxTextOffsetY)
	elseif G_GamePaused then
		love.graphics.print("Score: " .. G_GameScore .. "\n::GAME PAUSED::\n\nPress ENTER to Continue.\n\nPress ESCAPE to quit.", G_GfxTextOffsetX, G_GfxTextOffsetY)
	else
		love.graphics.print("Score: " .. G_GameScore, G_GfxTextOffsetX, G_GfxTextOffsetY)
	end
	--love.graphics.print("Speed: " .. math.floor(G_GameSpeed*100)/100, 350, 10)
end

function love.keypressed(sKey,sScanCode,bRepeat)
	if not G_GamePaused then
	if sKey == "left" then
	 	G_GameGrid:GridMove(-1,0)
	elseif sKey == "right" then
	 	G_GameGrid:GridMove(1,0)
	elseif sKey == "down" then
		G_GameGrid:UpdateGridDown()
		G_GameTimer = 0
	elseif sKey == "up" then
		G_GameGrid:GridRotate()
	elseif sKey == "return" or sKey == "escape" then
		G_GamePaused = true
	end
	elseif sKey == "return" then
		if G_GameEnded then
			GameStart()
		end
		G_GamePaused = false
	elseif sKey == "escape" then
		love.event.quit()
	end

	if sKey == "m" then
		ToggleMusic()
	end
end

function love.keyreleased(sKey, sScancode )
end

function love.mousepressed( x, y, button, istouch )
end

function love.mousereleased( x, y, button, istouch )
end

function love.mousemoved( x, y, dx,dy )
end
function HSV(h, s, v)
    if s <= 0 then return v,v,v end
    h, s, v = h/256*6, s/255, v/255
    local c = v*s
    local x = (1-math.abs((h%2)-1))*c
    local m,r,g,b = (v-c), 0,0,0
    if h < 1     then r,g,b = c,x,0
    elseif h < 2 then r,g,b = x,c,0
    elseif h < 3 then r,g,b = 0,c,x
    elseif h < 4 then r,g,b = 0,x,c
    elseif h < 5 then r,g,b = x,0,c
    else              r,g,b = c,0,x
    end return (r+m)*255,(g+m)*255,(b+m)*255
end

function DDPrint(sText)
	DDText = DDText .. "\n" .. sText
end

function Score(n)
	G_GameScore = G_GameScore + n*125
	G_GameSpeed = G_GameSpeed * 0.95
end


function GameEnd()
--love.graphics.setFont(ENDFont);
	G_SoundEnd:play()
	SaveHighScore(G_GameScore)
	G_GamePaused = true
	G_GameEnded = true
end

function GameStart()
--love.graphics.setFont(DAFont);
	G_GameScore = 0
	G_GameSpeed = 2
	G_GamePaused = false
	G_GameEnded = false
	G_GameGrid:GameStart()
end

function SaveHighScore(n)
	local highest = false
	if n > G_HighScore then
		G_HighScore = n
		highest = true
	end
	if highest then
		local file, errorstr = love.filesystem.newFile( "HIGHSCORE", "w" )
		if errorstr then
			print(errorstr)
		else
			local success, err = file:write( G_HighScore )
			file:close()
			if err then
				print(err)
			end
		end
	end
	return highest
end

function LoadHighScore()
	local n = 0
	--Read HighScore
	local contents, size = love.filesystem.read( "HIGHSCORE" )
	if tonumber(contents) then n = tonumber(contents) end
	--Return
	return n
end

function ToggleMusic()
	if G_Music_Current ~= 0 then
		G_Music[G_Music_Current]:stop()
	end
	G_Music_Current = G_Music_Current + 1
	if G_Music_Current > #G_Music then
		G_Music_Current = 0
	end
	if G_Music_Current ~= 0 then
		G_Music[G_Music_Current]:play()
	end
end
