GameTile = class(function(self,_shape,_colourRed,_colourGreen,_colourBlue)
	local __shape = _shape or 1
	local __colourRed = 	_colourRed or 255
	local __colourGreen = _colourGreen or 255
	local __colourBlue = 	_colourBlue or 255
	self:InitTile(__shape,__colourRed,__colourGreen,__colourBlue)
	return self
end)

GameTile.InitTile = function(self,_shape,_colourRed,_colourGreen,_colourBlue)
	self.colour = {r=_colourRed,g=_colourGreen,b=_colourBlue}
	self.shape = {}
	self.pos = {x=5,y=1}
	local x = 0
	local y = 0
	if _shape == 1 then --line
		self.shape[1] = {x=-1,y=0}
		self.shape[2] = {x=0,y=0}
		self.shape[3] = {x=1,y=0}
		self.shape[4] = {x=2,y=0}
	elseif _shape == 2 then --t shape
		self.shape[1] = {x=-1,y=0}
		self.shape[2] = {x=0,y=0}
		self.shape[3] = {x=1,y=0}
		self.shape[4] = {x=0,y=1}
	elseif _shape == 3 then --l shape
		self.shape[1] = {x=-1,y=0}
		self.shape[2] = {x=0,y=0}
		self.shape[3] = {x=1,y=0}
		self.shape[4] = {x=1,y=1}
	elseif _shape == 4 then --l shape 2
		self.shape[1] = {x=-1,y=0}
		self.shape[2] = {x=0,y=0}
		self.shape[3] = {x=1,y=0}
		self.shape[4] = {x=-1,y=1}
	elseif _shape == 5 then --s shape
		self.shape[1] = {x=-1,y=0}
		self.shape[2] = {x=0,y=0}
		self.shape[3] = {x=0,y=1}
		self.shape[4] = {x=1,y=1}
	elseif _shape == 6 then --0 shape
		self.shape[1] = {x=0,y=0}
		self.shape[2] = {x=1,y=0}
		self.shape[3] = {x=0,y=1}
		self.shape[4] = {x=1,y=1}
	elseif _shape == 7 then --s shape
		self.shape[1] = {x=-1,y=1}
		self.shape[2] = {x=0,y=1}
		self.shape[3] = {x=0,y=0}
		self.shape[4] = {x=1,y=0}
	end
end


GameTile.GetTileShapePos = function(self)
	local t = {}
	for k,v in pairs(self.shape) do
		local x = v.x + self.pos.x
		local y = v.y + self.pos.y
		table.insert(t,{x=x,y=y})
	end
	return t
end

GameTile.Move = function(self,x,y)
	self.pos.x = self.pos.x + x
	self.pos.y = self.pos.y + y
end

GameTile.Rotate = function(self,d)
		for i=1,4 do
			self.shape[i] = {x=self.shape[i].y,y=self.shape[i].x*-1}
		end
end

GameTile.GetTileRotPos = function(self)
	local t = {}
	for k,v in pairs(self.shape) do
		local x = v.y + self.pos.x
		local y = v.x*-1 + self.pos.y
		table.insert(t,{x=x,y=y})
	end
	return t
end

GameTile.Destroy = function (self)
	self = nil
end
